
/// ????? ???????? ?????? (Brenkman Andrey)
/// ????????? ?????????  8.09.2011
/// ??????? ????? ??????? 0%

#include "gcc-compat.h"


///!
#include "a_move_list_struct.h"


/// ????????-?????????(1-0) ????? ?????? ? ???? ???????? ??????????
#define TEST_HISTORY 0 

/*

History heuristic
http://chessprogramming.wikispaces.com/History+Heuristic

 History heuristic is a dynamic move ordering method based on 
 the number of cutoffs caused by a given move irrespectively 
 from the position in which the move has been made. The Heuristic 
 was invented by Jonathan Schaeffer in 1983 [1] and works as follows: 
 on a cutoff we increment a counter in a special table, addressed 
 either by [from][to] (the Butterfly Boards) or by [piece][to]. 
 The added value is typically depth * depth or 2 ^ depth, based 
 on the assumption that otherwise moves from the plies near the 
 leaves would have to much impact on the result. Values retrieved 
 from that table are used to order non-capturing moves. This simple 
 heuristics performs usually better than domain-dependent heuristics, 
 though it may be combined with them. For example, in Rebel only a 
 few non-captures are ordered by history heuristics, then a 
 piece-square approach is used [2] . In the literature, history 
 heuristic is often presented as depth-independent generalization 
 of the killer moves. It is also said to reflect long-term plans 
 in a position.

 However, all of those statements were made at the time when typical 
 search depth was much lower than today. Nowadays authors of the leading 
 programs say that given enough search depth, history heuristic produces 
 just a random noise. In Crafty it is not used anymore [3] , 
 whereas Ed Schrder, author of Rebel, advocated not taking into account 
 the cutoffs from the last couple of plies.

 This is how the history array may be updated, if a beta-cutoff occurs:

   if ( score >= beta ) { // cutoff
      if ( isNonCapture (move) )
         history[move.from][move.to] += depth*depth; // 1 << depth
      ...
      return score;
   }

end link(????? ??????)---------------------
*/

/*
 ????????? ???????

 ???? ???  ??? ?? ??????? ????? ? ?????? ??????? ?? ????
 ?????? ??? ??????? ? ??? ????????? ???????? 
 ??????? ??? ??? ?????? ?? ?????
 ??? ?????? ??????? ???? ? ?????? ??????? ?? ?????

*/

namespace History_heuristic
{

/// ???? ??????
//////////////////////////////////////////////////////////////////////////////////////
//private:

//////////////////////////////////////////////////////////////////////////////////////
//public:

	///---------------------------------------------------------------------------
	///
	int32_t get_white_history
	(
		const uint8_t n,///
		const uint8_t c ///
	);

	///---------------------------------------------------------------------------
	///
	int32_t get_black_history
	(
		const uint8_t n,///
		const uint8_t c ///
	);

//////////////////////////////////////////////////////////////////////////////////////
//public:

	///---------------------------------------------------------------------------
	/// ?????????????? ?????? ???????
	void ini_history();

	///---------------------------------------------------------------------------
	/// ????? ???????
	void white_history_good_save
	(
		const uint8_t i,/// ????? ???? ? ??????
		struct List & list,/// ????????????? ?????? ?????
		const uint8_t depth,// ??????? ?????? ????
		const uint8_t depth_max// ???????????? ??????? ???????
	);

	///---------------------------------------------------------------------------
	/// ????? ???????
	void black_history_good_save
	(
		const uint8_t i,/// ????? ???? ? ??????
		struct List & list,/// ????????????? ?????? ?????
		const uint8_t depth,// ??????? ?????? ????
		const uint8_t depth_max// ???????????? ??????? ???????
	);

	///---------------------------------------------------------------------------
	/// ????? ???????
	inline void white_history_bad_save
	(
		const uint8_t e,/// ????? ???? ? ??????
		struct List & list,/// ????????????? ?????? ?????
		const uint8_t depth,// ??????? ?????? ????
		const uint8_t depth_max// ???????????? ??????? ???????
	);

	///---------------------------------------------------------------------------
	/// ????? ???????
	inline void black_history_bad_save
	(
		const uint8_t e,/// ????? ???? ? ??????
		struct List & list,/// ????????????? ?????? ?????
		const uint8_t depth,// ??????? ?????? ????
		const uint8_t depth_max// ???????????? ??????? ???????
	);

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
// ????????
// ???????????? ???????
#if TEST_HISTORY

	void History_heuristic::test_print
	(	
		const uint8_t depth_max// ???????????? ??????? ???????
	);

#endif

};
