
//  Tord Romstad
//   17.09.2007 1.05.2010


#include "gcc-compat.h"

#if defined(__GNUC__) && !defined(__MINGW32__)

int WIN_32_TORD_ROMSTAD_BIOSKEY::public_bioskey(void)
{
  fd_set readfds;
  struct timeval timeout;

  FD_ZERO(&readfds);
  FD_SET(fileno(stdin), &readfds);
   /* Set to timeout immediately */
  timeout.tv_sec = 0;
  timeout.tv_usec = 0;
  select(16, &readfds, 0, 0, &timeout);

  return (FD_ISSET(fileno(stdin), &readfds));
}

#else

/* Windows-version */
#include <windows.h>
#include <conio.h>


//     Glaurung121 by Tord Romstad
// -     :)


namespace WIN_32_TORD_ROMSTAD_BIOSKEY
{
	int init = 0;
	int pipe;
	HANDLE inh;
}

//	===================================================================
//        
int WIN_32_TORD_ROMSTAD_BIOSKEY::public_bioskey(void)
{
	DWORD dw;

	/* If we're running under XBoard then we can't use _kbhit() as the input
	* commands are sent to us directly over the internal pipe */

#if defined(FILE_CNT)
	if (stdin->_cnt > 0)
	{
		return stdin->_cnt;
	}
#endif

	if (!init)
	{
		init = 1;
		inh = GetStdHandle(STD_INPUT_HANDLE);
		pipe = !GetConsoleMode(inh, &dw);

        if (!pipe)
		{
			SetConsoleMode(inh, dw & ~(ENABLE_MOUSE_INPUT | ENABLE_WINDOW_INPUT));
			FlushConsoleInputBuffer(inh);
		}
	}

    if (pipe)
	{
		if (!PeekNamedPipe(inh, NULL, 0, NULL, &dw, NULL))
		{
			return 1;
		}
		return dw;
    }
	else
	{
		GetNumberOfConsoleInputEvents(inh, &dw);
		return dw <= 1 ? 0 : dw;
	}
}

#endif

