
//    (Brenkman Andrey)
//   5.12.2008 19.11.2009 22.06.10 22.11.10 28.09.2011

#include <fstream>
#include <iostream>

#include "a_move_list_struct.h"
#include "b_constants.h"
#include "b_search_const.h"
#include "search_quiescence.h"
#include "evaluate.h"
#include "move_generation.h"
#include "make_move.h"
#include "move_ordering.h"
#include "pv_save.h"
#include "_search_switch.h"


//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

/*

   

      .     .

       -   
         .     
    .

          - 
        .

        .    
         .      
 .   .           .
           .  
           .    
         .    
          .
   
              
      .        
       .    
               .

              
                  
  .             
    .

1)    .

  1.1         .   
      .

  1.2         . 

  1.3     1:

	if (value_stat > alpha)
	{ 
		if (value_stat >= beta)
		{
			return value_stat;
		}

		alpha = value_stat;
		save_best = 1;
	}

---------------------------------------
2)     mvv/lva   .  
       .

  2.1    -. 

  2.2     2:
	value_max_din = value_stat;

	if (value_din > value_max_din)
	{
		value_max_din = value_din;

		if (value_din > alpha)
		{
			if (value_din >= beta)
			{
				return value_din;
			}

			alpha = value_din;

			//       
			PVSAVE::public_update_PV_best_point(&pv_best_point);

			save_best = 1;
		}
	}

        
             
	if (save_best == 1)
	{
		if (value_max_din == value_stat)
		{
			//     

			//            
			//      
			PVSAVE::public_update_PV_best_max_depth(value_stat,depth); 
		}
		else
		{
			//         PV_best       
			PVSAVE::public_update_PV_best(&pv_best_point);
		}
	}

*/

//	===================================================================
//     
int32_t Search_quiescence::forced_variant_white
(
	struct Position & position,//  
	int32_t alpha,//
	const int32_t beta,//
	const uint8_t depth,// 
	const bool flag_pv_f//     (pv)
)
{
	bool save_best = 0;//    
	int32_t value_din; //  
	int32_t value_stat; //  
	int32_t value_max_din; //   
	const uint8_t new_depth = depth + 1; //  

	struct List list_surplus_moves;//    (    )

	struct PV_line pv_best_point;//     

#if DELTA_PRUNING
	///    
	const uint64_t save_all_black_piece = position.all_black_piece;
#endif //#if DELTA_PRUNING

	//    
	value_stat = position.value_white_material
		- position.value_black_material
		+ Evaluate::eval_state(position)
		;

	//  
	//value_stat = (bitboard.value_white_material - bitboard.value_black_material);


	//------------------------------------------------
	// TEST
	//      

	//if (Evaluate::eval_white_material(position) != position.value_white_material)
	//{
	//	std::cout << "WHITE eval_white_material != bitboard.value_white_material" <<std::endl;
	//	std::cout << "eval_white_material(position)= "<< Evaluate::eval_white_material(position)<<std::endl;
	//	std::cout << "position.value_white_material= "<< position.value_white_material<<std::endl;
	//	exit(1);
	//}

	//if (Evaluate::eval_black_material(position) != position.value_black_material)
	//{
	//	std::cout << "WHITE eval_black_material != position.value_black_material" <<std::endl;
	//	std::cout << "eval_black_material(position)= "<< Evaluate::eval_black_material(position)<<std::endl;
	//	std::cout << "position.value_black_material= "<< position.value_black_material<<std::endl;
	//	exit(1);
	//}

	//if (Evaluate::eval_difference_material(position) 
	//	!= (position.value_white_material - position.value_black_material) )
	//{
	//	std::cout << "WHITE eval_difference_material != (position.value_white_material - position.value_black_material)" <<std::endl;
	//	std::cout << "eval_difference_material(position)= "<< Evaluate::eval_difference_material(position)<<std::endl;
	//	std::cout << "(position.value_white_material - position.value_black_material)= " << (position.value_white_material - position.value_black_material)<<std::endl;
	//	exit(1);
	//}
	//------------------------------------------------


	//        .
	if (value_stat > alpha)
	{ 
		//      
		//    ?
		//             
		//      
		//  
		//             
		//       
		if (value_stat >= beta)
		{
			return value_stat;
		}

		alpha = value_stat;
		save_best = 1;
	}
 
    //
	value_max_din = value_stat;

#if DELTA_PRUNING
	/*
	         
	captures_mask = (all_black_piece & knigt_moves_masks[from]);
	    all_black_piece   
	    
	*/

	if (value_stat < (alpha - PAWN_MARGIN) )//   
	{
		// 
		value_max_din = value_stat + PAWN_MARGIN;

		position.all_black_piece = position.all_black_piece 
			^ position.black_piece[N_PAWN];

		if (value_stat < (alpha - MAX_BISHOP_KNIGHT_MARGIN) )//     
		{
			// 
			value_max_din = value_stat + MAX_BISHOP_KNIGHT_MARGIN;

			position.all_black_piece = position.all_black_piece 
				^ position.black_piece[N_KNIGHT];

			position.all_black_piece = position.all_black_piece 
				^ position.black_piece[N_BISHOP];

			if (value_stat < (alpha - ROOK_MARGIN) )//   
			{
			// 
			value_max_din = value_stat + ROOK_MARGIN;

				position.all_black_piece = position.all_black_piece 
					^ position.black_piece[N_ROOK];

				if (value_stat < (alpha - QUEEN_MARGIN) )//   
				{
				// 
				value_max_din = value_stat + QUEEN_MARGIN;

					position.all_black_piece = position.all_black_piece 
						^ position.black_piece[N_QUEEN];
				}
			}
		}
	}
#endif //#if DELTA_PRUNING

	//      
	Move_generation::generator_captures_white(list_surplus_moves,position);
	//if (depth == 2) List_Print_F(depth, &list_surplus_moves);
	Move_ordering::sorting_moves_captures(list_surplus_moves);
	//if (depth == 2) List_Print_F(depth, &list_surplus_moves);

#if DELTA_PRUNING
	//    
	position.all_black_piece = save_all_black_piece;
#endif //#if DELTA_PRUNING


	//     
	//   - 
	for (uint8_t i = 0; i < list_surplus_moves.end_captures; i++)
	{
		//TEST
		//cout << "white depth= " << depth<<std::endl;
		//cout << "i = " << i <<std::endl;
		//cout << "list_surplus_moves.move[i] & 63 = " << (list_surplus_moves.move[i] & 63) <<std::endl;

		//  
		Make_move::do_moves_white(position,i,depth,list_surplus_moves);

		//           
		//   .
		if (flag_pv_f)
		{
			PV_save::update_PV_current(i,depth,list_surplus_moves);
		}

		//    
		if ((list_surplus_moves.move[i] & 63) != 6)
		{
			//   
			value_din = forced_variant_black(position,alpha,beta,new_depth
				,flag_pv_f);

			//  
			Make_move::undo_moves_white(position,i,depth,list_surplus_moves);


			if (value_din > value_max_din)
			{

				//AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
				if (value_din > alpha) 
				{
					if (value_din >= beta)
					{
						return value_din;
					}

					alpha = value_din; 

					//       
					//  
					if (flag_pv_f)
					{
						PV_save::update_PV_best_point(pv_best_point);
					}

					save_best = 1;
				}
				//AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

				value_max_din = value_din;
			}

		}//    
		else
		{
			//   !
			value_stat = (VALUE_MATE - depth * DELTA_MATE);

			Make_move::undo_moves_white(position,i,depth,list_surplus_moves);

			//            
			//      
			if (flag_pv_f)
			{
				PV_save::update_PV_best_max_depth(value_stat,depth);
			}

			return value_stat;

		}
	}

	/*
	           
	     
	*/
	if (save_best == 1)
	{
		if (value_max_din == value_stat)
		{//     

			//            
			//      
			if (flag_pv_f)
			{
				PV_save::update_PV_best_max_depth(value_stat,depth);
			}
		}
		else
		{
			//         
			// PV_best       
			if (flag_pv_f)
			{
				PV_save::update_PV_best(pv_best_point);
			}
		}
	}
	return value_max_din;
}

//	===================================================================
//     
int32_t Search_quiescence::forced_variant_black
(
	struct Position & position,//  
	const int32_t alpha,//
	int32_t beta,//
	const uint8_t depth,// 
	const bool flag_pv_f//     (pv)
)
{
	bool save_best = 0;//    
	int32_t value_din; //  
	int32_t value_stat; //  
	int32_t value_min_din; //  
	const uint8_t new_depth = depth + 1; //  

	struct List list_surplus_moves; //    (    )

	struct PV_line pv_best_point;//     

#if DELTA_PRUNING
	///    
	const uint64_t save_all_white_piece = position.all_white_piece;
#endif //#if DELTA_PRUNING

	value_stat = position.value_white_material
		- position.value_black_material
		+ Evaluate::eval_state(position)
		;
 
	//  
	//value_stat = bitboard.value_white_material - bitboard.value_black_material;

	//------------------------------------------------
	// TEST
	//      

	//if (Evaluate::eval_white_material(position) != position.value_white_material)
	//{
	//	std::cout << "WHITE eval_white_material != bitboard.value_white_material" <<std::endl;
	//	std::cout << "eval_white_material(position)= "<< Evaluate::eval_white_material(position)<<std::endl;
	//	std::cout << "position.value_white_material= "<< position.value_white_material<<std::endl;
	//	exit(1);
	//}

	//if (Evaluate::eval_black_material(position) != position.value_black_material)
	//{
	//	std::cout << "WHITE eval_black_material != position.value_black_material" <<std::endl;
	//	std::cout << "eval_black_material(position)= "<< Evaluate::eval_black_material(position)<<std::endl;
	//	std::cout << "position.value_black_material= "<< position.value_black_material<<std::endl;
	//	exit(1);
	//}

	//if (Evaluate::eval_difference_material(position) 
	//	!= (position.value_white_material - position.value_black_material) )
	//{
	//	std::cout << "WHITE eval_difference_material != (position.value_white_material - position.value_black_material)" <<std::endl;
	//	std::cout << "eval_difference_material(position)= "<< Evaluate::eval_difference_material(position)<<std::endl;
	//	std::cout << "(position.value_white_material - position.value_black_material)= " << (position.value_white_material - position.value_black_material)<<std::endl;
	//	exit(1);
	//}
	//------------------------------------------------


	if (value_stat < beta)
	{
		if (value_stat <= alpha)
		{
			return value_stat;
		}

		beta = value_stat;
		save_best = 1;
	}


	//
	value_min_din = value_stat;

#if DELTA_PRUNING

	if (value_stat > (beta + PAWN_MARGIN) )
	{
		value_min_din = value_stat - PAWN_MARGIN;
		position.all_white_piece = position.all_white_piece 
			^ position.white_piece[N_PAWN];

		if (value_stat > (beta + MAX_BISHOP_KNIGHT_MARGIN) )
		{
			value_min_din = value_stat - MAX_BISHOP_KNIGHT_MARGIN;
			position.all_white_piece = position.all_white_piece 
				^ position.white_piece[N_KNIGHT];
			position.all_white_piece = position.all_white_piece 
				^ position.white_piece[N_BISHOP];      

			if (value_stat > (beta + ROOK_MARGIN) )
			{
				value_min_din = value_stat - ROOK_MARGIN;
				position.all_white_piece = position.all_white_piece 
					^ position.white_piece[N_ROOK];

				if (value_stat > (beta + QUEEN_MARGIN) )
				{
					value_min_din = value_stat - QUEEN_MARGIN;
					position.all_white_piece = position.all_white_piece 
						^ position.white_piece[N_QUEEN];
				}
			}
		}
	}
#endif //#if DELTA_PRUNING

	//   
	Move_generation::generator_captures_black(list_surplus_moves,position);
	Move_ordering::sorting_moves_captures(list_surplus_moves);

#if DELTA_PRUNING
	//    
	position.all_white_piece = save_all_white_piece;
#endif //#if DELTA_PRUNING

	//           

	//    
	//     
	for (uint8_t i = 0; i < list_surplus_moves.end_captures; i++)
	{
		//TEST
		//cout << "black depth= " << depth<<std::endl;
		//cout << "i = " << i <<std::endl;
		//cout << "list_surplus_moves.move[i] & 63 = " << (list_surplus_moves.move[i] & 63) <<std::endl;

		//  
		Make_move::do_moves_black(position,i,depth,list_surplus_moves);

		//           
		//   .
		if (flag_pv_f)
		{
			PV_save::update_PV_current(i,depth,list_surplus_moves);
		}

		//    
		if ((list_surplus_moves.move[i] & 63) != 6)
		{
			//   
			value_din = forced_variant_white(position,alpha,beta,new_depth
				,flag_pv_f);

			//  
			Make_move::undo_moves_black(position,i,depth,list_surplus_moves);


			if (value_din < value_min_din)
			{
				//AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
				if (value_din < beta)
				{
					if (value_din <= alpha)
					{
						return value_din;
					}

					beta = value_din; 

					//       
					//  
					if (flag_pv_f)
					{
						PV_save::update_PV_best_point(pv_best_point);
					}

					save_best = 1;
				}
				//AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

				value_min_din = value_din;
			}

		
		}//    
		else
		{
			//  !
			value_stat = -(VALUE_MATE - depth * DELTA_MATE);
			Make_move::undo_moves_black(position,i,depth,list_surplus_moves);

			//            
			//      
			if (flag_pv_f)
			{
				PV_save::update_PV_best_max_depth(value_stat,depth);
			}

			return value_stat;

		}
	}

	if (save_best == 1)
	{
		if (value_min_din == value_stat)
		{
			//     

			//            
			//      
			if (flag_pv_f)
			{
				PV_save::update_PV_best_max_depth(value_stat,depth);
			}
		}
		else
		{
			//         PV_best 
			//       
			if (flag_pv_f)
			{
				PV_save::update_PV_best(pv_best_point);
			}
		}
	}
	return value_min_din;
}

//	===================================================================
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
//  
