
//    (Brenkman Andrey)
//   9.03.2009 20.1.2010 3.6.2012

#include <fstream>
#include <iostream>

#include "transposition_table.h"
#include "b_constants.h"
#include "a_hash_moves_struct.h"


//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
 std::ofstream Test_Hash;
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

	///     -
	uint64_t max_index_hash;

	///   -(   )
	struct Hash_moves * p_hash_moves;

	///   .        
	uint8_t age; 

	//   
	bool flag_found_score;


//   -  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if TEST_WRITE_READ

//	===================================================================
//  
 void HASHM::test_hash_ini()
 {
	//     --------------------------------------

	//    
	hash_write_all = 0;

	//      
	hash_move_write = 0;

	//       
	hash_score_write_low = 0;

	//       
	hash_score_write_high = 0;

	//   ---------------------------------------- 

	//    
	hash_read_sorting = 0; 

	//       
	hash_read_score = 0;  

	hash_read_score_LOWER = 0;

	hash_read_score_UPPER = 0;

 }

//	===================================================================
//  
void HASHM::test_hash_print()
{
	std::cout << " " << std::endl;

	hash_write_all = hash_move_write + hash_score_write_low + hash_score_write_high;

	//     
	std::cout << "hash_write_all = " << hash_write_all << std::endl;

	if (hash_write_all != 0)
	{
		//      
		std::cout << "hash_move_write = " << hash_move_write << "   100 * hash_move_write/hash_write_all = " << 100 * hash_move_write/hash_write_all << std::endl;

		//       
		std::cout << "hash_score_write_low = " << hash_score_write_low << "   100 * hash_score_write_low/hash_write_all = " << 100 * hash_score_write_low/hash_write_all << std::endl;

		//       
		std::cout << "hash_score_write_high = " << hash_score_write_high << "   100 * hash_score_write_high/hash_write_all = " << 100 * hash_score_write_high/hash_write_all << std::endl;

		std::cout << " " << std::endl;

		//      
		std::cout << "hash_read_sorting = " << hash_read_sorting << "   100 * hash_read_sorting/hash_write_all = " << 100 * hash_read_sorting/hash_write_all << std::endl;
	}

	//     
	std::cout << "hash_write_all - hash_read_sorting = " << (hash_write_all - hash_read_sorting) << std::endl;


	std::cout << " " << std::endl;

	hash_read_score = hash_read_score_LOWER + hash_read_score_UPPER;

	if ( hash_read_score != 0)
	{
		if (hash_write_all != 0)
		{
			//     
			std::cout << "hash_read_score = " << hash_read_score << "   100 * hash_read_score/hash_write_all = " << 100 * hash_read_score/hash_write_all << std::endl;

			//     
			std::cout << "hash_read_all = " << (hash_read_sorting + hash_read_score) << "   100 * hash_read_all/hash_write_all = " << 100 * (hash_read_sorting + hash_read_score)/hash_write_all << std::endl;
		}

		//        
		std::cout << "hash_read_score_LOWER = " << hash_read_score_LOWER <<  "   100 * hash_read_score_LOWER/hash_read_score = " << 100 * hash_read_score_LOWER/hash_read_score << std::endl;

		//        
		std::cout << "hash_read_score_UPPER = " << hash_read_score_UPPER <<  "   100 * hash_read_score_UPPER/hash_read_score = " << 100 * hash_read_score_UPPER/hash_read_score << std::endl;
	}

	std::cout << " " << std::endl;
 }

#endif // TEST_WRITE_READ
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



//    -  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

bool Transposition_table::get_flag_found_score()
{
	return flag_found_score;
}


//	===================================================================
//    .    
void Transposition_table::hash_size_ini_default
(
	uint16_t hash_size//  -  
)
{
	uint64_t hash_n = 0;

	if (hash_size < 1) hash_size = 1;//    
	if (hash_size > 1024) hash_size = 1024;//    

	//  sizeof(structHash_moves)     .. int  4
	//    structHash_moves - 16 
	//           
	max_index_hash = (uint64_t)(
		(hash_size * (1024 * 1024)) / sizeof(struct Hash_moves));

	//std::cout << "max_index_hash in 1 mb = " << max_index_hash << std::endl;
	//std::cout << "sizeof(Hash_moves) = " << sizeof(struct Hash_moves) << std::endl;
	//std::cout << "sizeof(unsigned int) = " << sizeof(unsigned int) << std::endl;

	//     (2   n) -1    
	//   000..0111      -      &
	for (hash_n = 2; hash_n <= max_index_hash; hash_n = 2 * hash_n );

	hash_n = hash_n / 2;

	if ((hash_n & (hash_n - 1)) != 0)
	{
		std::cout << "!      " << hash_n << std::endl;
	}

	max_index_hash = hash_n - 1;

	// calloc
	// Allocates a block of memory for an array of num elements, 
	// each of them size bytes long, and initializes all its bits to zero.
	//        
	p_hash_moves = (struct Hash_moves*) calloc (
		(int32_t)(max_index_hash + 3), sizeof(struct Hash_moves));

	if (p_hash_moves == NULL) 
	{
		std::cout << "  " << std::endl;
		exit(1); 
	}

	// TEST
	//std::cout << "sizeof(Hash_moves) = " << sizeof(Hash_moves) << std::endl;
	//std::cout << "max_index_hash = " << max_index_hash << std::endl;
	//std::cout << "hash_n = " << hash_n << std::endl;

}

//	===================================================================
//     - 
//       .    
void Transposition_table::hash_size_resize
(
	uint16_t hash_size//  -  
)
{
	uint64_t hash_n = 0;

	if (p_hash_moves == NULL) 
	{
		std::cout << "  " << std::endl;
		exit(1); 
	}

	free(p_hash_moves);//    

	if (hash_size < 1) hash_size = 1;//    
	if (hash_size > 1024) hash_size = 1024;//    

	//           
	max_index_hash = (uint64_t)(
		(hash_size * (1024 * 1024)) / sizeof(struct Hash_moves));

    // TEST
	//std::cout << " max_index_hash = " << max_index_hash << std::endl;
 

	//     (2   n) -1    
	//   000..0111      -      &
	for (hash_n = 2; hash_n <= max_index_hash; hash_n = 2 * hash_n );

	hash_n = hash_n / 2;

	if ((hash_n & (hash_n - 1)) != 0)
	{
		std::cout << "!      " << hash_n << std::endl;
	}

	max_index_hash = hash_n - 1;

	//        
	p_hash_moves = (struct Hash_moves*) calloc (
		(int32_t)(max_index_hash + 3), sizeof(struct Hash_moves));

	if (p_hash_moves == NULL) 
	{
		std::cout << "  " << std::endl;
		exit(1); 
	}

// TEST
	//std::cout << "  -   hash_size = " << hash_size << std::endl;
	//std::cout << "       = " << ((int)(max_index_hash + 3) * sizeof(Hash_moves))/(1024 * 1024) << std::endl;
	//std::cout << "    sizeof(Hash_moves) = " << sizeof(Hash_moves) << std::endl;
	//std::cout << "  2 hash_n = " << hash_n << std::endl;
	//std::cout << "   - max_index_hash = " << max_index_hash << std::endl;

}

//	===================================================================
//     -
void Transposition_table::hash_size_free()
{
	if (p_hash_moves != NULL)
	{
		free(p_hash_moves);
	}
}

//	===================================================================
//    - 0
void Transposition_table::ini_hash_moves()
{    
	if (p_hash_moves != NULL)
	{
		for (uint32_t ihm = 0; ihm <= max_index_hash; ihm++)
		{
			p_hash_moves[ihm].key_lock_32_move = 0;
			p_hash_moves[ihm].key_lock_32_score = 0;
		}
	}
}

//	===================================================================
//         (  )
void Transposition_table::save_best_hash_score_or_move
(
	uint8_t i,//    
	uint64_t key,// -
	const struct List & list_surplus_moves,//  
	int32_t score,//  
	uint8_t flag_hash_score,//   (1-  (); 3-  (); 2-  ())
	uint8_t depth,//   
	uint8_t depth_max//   
)
{
	uint32_t ind = (uint32_t)(key & max_index_hash);
	uint32_t key_lock_32 = (uint32_t)(key >>32);
	uint8_t delta_depth = depth_max - depth;

	if (delta_depth < 0) delta_depth = 0;

	/*
	      
	          
	        

	          -
	      
	          
	*/

	//   
	save_best_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);

	//   
	save_best_hash_score(key_lock_32,score,flag_hash_score,delta_depth,ind);
}

//	===================================================================
//         (  )
void Transposition_table::save_best_hash_move
(
	uint8_t i,//    
	uint64_t key,// -
	const struct List & list_surplus_moves,//  
	int32_t score,//  
	uint8_t flag_hash_score,//   (1-  (); 3-  (); 2-  ())
	uint8_t depth,//   
	uint8_t depth_max//   
)
{
	uint32_t ind = (uint32_t)(key & max_index_hash);
	uint32_t key_lock_32 = (uint32_t)(key >>32);
	uint8_t delta_depth = depth_max - depth;

	if (delta_depth < 0) delta_depth = 0;

	/*

	*/

	//   
	save_best_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);

}


/*
            
  
   
*/
int32_t Transposition_table::look_hash_score_white
(
	const uint64_t key,// -
	const uint8_t depth,// 
	const uint8_t depth_max,//  
	const int32_t alpha,//
	const int32_t beta,//
	uint8_t & test_flag_hash_moves,//   (1-  (); 
										   // 3-  (); 
										   // 2-  ())
	uint8_t & hash_depth,//  
	uint8_t & hash_depth_max//  
)
{
	uint32_t ind = (uint32_t)(key & max_index_hash);
	uint32_t key_lock_32 = (uint32_t)(key >>32);


	/*
	   
	    -   :

	1)LOWER ( score >= beta )
	        beta.  
	..       .
	             
	  score >= beta

	2)EXACT ( score  > alpha )&&( score < beta)
	     .. beta > score > alpha
	          -   
	        

	3)UPPER ( score < alpha )
	           .  
	(  ).
	*/

	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::look_hash_score_white  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	//              
	if (p_hash_moves[ind].key_lock_32_score == key_lock_32)
	{

		/*
			        
			    
			      
			  
		*/
		if (p_hash_moves[ind].score_delta_depth >= (depth_max - depth))
		{
			//--------------------------------------------------------
			if ((p_hash_moves[ind].flag_hash_score == BETA_CUTOFF)
				)
			{

				/*
					LOWER ( score >= beta )
					   
					        	
				*/
				if (p_hash_moves[ind].score >= beta)
				{ 
#if TEST_WRITE_READ
					// 
					hash_read_score_LOWER = hash_read_score_LOWER + 1;
#endif // TEST_WRITE_READ
					flag_found_score = true;
					return p_hash_moves[ind].score;
				} 
			}
			//--------------------------------------------------------

			//--------------------------------------------------------
			if ((p_hash_moves[ind].flag_hash_score == ALPHA_UPDATED)
				)
			{
				/*
					EXACT ( score  > alpha )
					&&(p_hash_moves[ind].score < beta)
					      
					       
					          
					    
					       
					     
				*/
				if ((p_hash_moves[ind].score > alpha)
					&&(p_hash_moves[ind].score < beta))
				{ 
#if TEST_WRITE_READ
					// 
					hash_read_score_LOWER = hash_read_score_LOWER + 1;
#endif // TEST_WRITE_READ
					flag_found_score = true;
					return p_hash_moves[ind].score;
				} 
			}
			//--------------------------------------------------------

			//--------------------------------------------------------
			if ((p_hash_moves[ind].flag_hash_score == LOCAL_MAX)
				)
			{
				/*
					UPPER ( score < alpha )
					    
				*/
				if (p_hash_moves[ind].score < alpha)
				{ 
#if TEST_WRITE_READ
					// 
					hash_read_score_LOWER = hash_read_score_LOWER + 1;
#endif // TEST_WRITE_READ
					flag_found_score = true;
					return p_hash_moves[ind].score;
				} 
			}
			//--------------------------------------------------------
		}
	}

	flag_found_score = false;
	return 0;
}

//	===================================================================
//             
//  
int32_t Transposition_table::look_hash_score_black
(
	const uint64_t key,// -
	const uint8_t depth,// 
	const uint8_t depth_max,//  
	const int32_t alpha,//
	const int32_t beta,//
	uint8_t & test_flag_hash_moves,//   (1-  (); 3-  (); 2-  ())
	uint8_t & hash_depth,//  
	uint8_t & hash_depth_max//  
)
{
	uint32_t ind = (uint32_t)(key & max_index_hash);
	uint32_t key_lock_32 = (uint32_t)(key >>32);

	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::look_hash_score_black  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}


	if (p_hash_moves[ind].key_lock_32_score == key_lock_32)
	{
		if (p_hash_moves[ind].score_delta_depth >= (depth_max - depth))
		{
			//--------------------------------------------------------
			if ((p_hash_moves[ind].flag_hash_score == ALPHA_CUTOFF)
				)
			{
				if (p_hash_moves[ind].score <= alpha) 
				{ 
#if TEST_WRITE_READ
					// 
					hash_read_score_LOWER = hash_read_score_LOWER + 1;
#endif // TEST_WRITE_READ
					flag_found_score = true;
					return p_hash_moves[ind].score;
				}
			}
			//--------------------------------------------------------

			//--------------------------------------------------------
			if ((p_hash_moves[ind].flag_hash_score == BETA_UPDATED)
				)
			{
				if ((p_hash_moves[ind].score < beta) 
					&&(p_hash_moves[ind].score > alpha)) 
				{ 
#if TEST_WRITE_READ
					// 
					hash_read_score_LOWER = hash_read_score_LOWER + 1;
#endif // TEST_WRITE_READ
					flag_found_score = true;
					return p_hash_moves[ind].score;
				}
			}
			//--------------------------------------------------------

			//--------------------------------------------------------
			if ((p_hash_moves[ind].flag_hash_score == LOCAL_MIN)
				)
			{
				if (p_hash_moves[ind].score > beta) 
				{ 
#if TEST_WRITE_READ
					// 
					hash_read_score_LOWER = hash_read_score_LOWER + 1;
#endif // TEST_WRITE_READ
					flag_found_score = true;
					return p_hash_moves[ind].score;
				}
			}
			//--------------------------------------------------------
		}
	}

	flag_found_score = false;
	return 0;
}

//	===================================================================
//              
void Transposition_table::look_hash_move
(
	struct List & list_surplus_moves,//  
	const uint64_t key,// -
	const uint8_t depth,// 
	uint8_t  & flag_insert_hash_move//     -     
)
{
	uint32_t ind = (uint32_t)(key & max_index_hash);


	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::look_hash_move  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	//              
	if (p_hash_moves[ind].key_lock_32_move == (uint32_t)(key >> 32))
	{
#if TEST_WRITE_READ
		//     
		hash_read_sorting = hash_read_sorting + 1;
#endif // TEST_WRITE_READ

		//       
		insert_hash_moves(list_surplus_moves,p_hash_moves[ind].move,flag_insert_hash_move);
	}
}

//	===================================================================
//   
void Transposition_table::set_age_0()
{
	age = 0;
}

//	===================================================================
//   
void Transposition_table::aging()
{
	if (age > 250) age = 0;

	age = age + 1;
	//std::cout << "age= " << (int32_t)age << std::endl;
}


//////////////////////////////////////////////////////////////////////////////////////////
//private:


//	===================================================================
//      
inline void Transposition_table::save_best_hash_move
(
	uint8_t i,//    
	uint32_t key_lock_32,//
	const struct List & list_surplus_moves,//  
	uint8_t delta_depth,//   
	uint32_t ind//
)
{
	/*

	       :
	1)   .      0
	     

	2)      
	  
	       ..   
	     

	    .       
	      .         
	       .  
	  -     .

	3)     
	      
	       ..   
	        . 

	-------------
	 :

	           .
	            .
	             
	    .

	          ,
	    .
	     

	  
	          
	              
	.               
	        .      
	             .

	                
	             
	 pv 

	       -     .
	           .. 
	  
	*/
  
	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::save_best_hash_move  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	//1)  
	if (p_hash_moves[ind].key_lock_32_move == 0)
	{
		//      
		save_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);

	}//2)   
	else if (p_hash_moves[ind].key_lock_32_move == key_lock_32) 
	{
		//   
		if (age == p_hash_moves[ind].move_age) 
		{
			//       
			if (delta_depth >= p_hash_moves[ind].move_delta_depth)
			{
				save_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);
			}
		}
		else// -      (       )
		{
			//    
			save_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);
		}

	}//3)  
	else if (p_hash_moves[ind].key_lock_32_move != key_lock_32) 
	{
		//   
		if (age == p_hash_moves[ind].move_age) 
		{
			//       
			if (delta_depth >= p_hash_moves[ind].move_delta_depth)
			{
				save_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);
			}
		}
		else
		{
			//    
			save_hash_move(i,key_lock_32,list_surplus_moves,delta_depth,ind);
		}
	}

}

//	===================================================================
//       
inline void Transposition_table::save_hash_move
(
	uint8_t i,//    
	uint32_t key_lock_32,//
	const struct List & list_surplus_moves,//  
	uint8_t delta_depth,//   
	uint32_t ind//   
)
{

	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::save_hash_move  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	//   32  
	p_hash_moves[ind].key_lock_32_move = key_lock_32;

	//   
	p_hash_moves[ind].move = list_surplus_moves.move[i];

	//       
	p_hash_moves[ind].move_delta_depth = delta_depth;

	//   
	p_hash_moves[ind].move_age = age;

#if TEST_WRITE_READ
	//   
	hash_move_write = hash_move_write + 1;
#endif // TEST_WRITE_READ

}

//	===================================================================
//      
inline void Transposition_table::save_best_hash_score
(
	uint32_t key_lock_32,//
	int32_t score,//  
	uint8_t flag_hash_score,//   (1-  (); 3-  (); 2-  ())
	uint8_t delta_depth,//   
	uint32_t ind//
)
{
	//      

	/*
	       :
	1)   .      0
	     

	2)     
	     ..   

	3)    
	     ,  ,  
	         .

	(          
	.)
	*/
  
	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::save_best_hash_score  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	// 1)  
	if (p_hash_moves[ind].key_lock_32_score == 0)
	{
		//      
		save_hash_score(key_lock_32,score,flag_hash_score,delta_depth,ind);

	}// 2)          
	else if (p_hash_moves[ind].key_lock_32_score == key_lock_32)
	{
		//         
		if (age <= p_hash_moves[ind].score_age + 1)
		{
			//       
			if(delta_depth >= p_hash_moves[ind].score_delta_depth)
			{
				save_hash_score(key_lock_32,score,flag_hash_score,delta_depth,ind);
			}

		}//    
		else
		{
			save_hash_score(key_lock_32,score,flag_hash_score,delta_depth,ind);
		}

	}// 3)    
	else if (p_hash_moves[ind].key_lock_32_score != key_lock_32)
	{
		//         
		if (age <= p_hash_moves[ind].score_age + 1)
		{
			//       
			if(delta_depth >= p_hash_moves[ind].score_delta_depth)
			{
				save_hash_score(key_lock_32,score,flag_hash_score,delta_depth,ind);
			}

		}//    
		else
		{
			save_hash_score(key_lock_32,score,flag_hash_score,delta_depth,ind);
		}
	}
}

//	===================================================================
//   ..    -
inline void Transposition_table::save_hash_score
(
	uint32_t key_lock_32,//
	int32_t score,//  
	uint8_t flag_hash_score,//   (1-  (); 3-  (); 2-  ())
	uint8_t delta_depth,//   
	uint32_t ind//
)
{

	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::save_hash_score  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	//   32  
	p_hash_moves[ind].key_lock_32_score = key_lock_32;

	//  
	p_hash_moves[ind].score = score;

	//   (1-  (); 3-  (); 2-  ())
	p_hash_moves[ind].flag_hash_score = flag_hash_score;

	//   
	p_hash_moves[ind].score_delta_depth = delta_depth;

	//  
	p_hash_moves[ind].score_age = age;


#if TEST_WRITE_READ

	if (flag_hash_score == HASHM::LOWER)
	{
		//   
       hash_score_write_low = hash_score_write_low + 1;
	}
	else
	{
		//   
		hash_score_write_high = hash_score_write_high + 1;
	}

#endif // TEST_WRITE_READ

}

//	===================================================================
//  -.         
void Transposition_table::TEST_Hash_index_print()
{

	uint32_t full_move = 0;
	uint32_t full_score = 0;

	uint32_t yes_move = 0;
	uint32_t yes_score = 0;

	uint32_t no_move = 0;
	uint32_t no_score = 0;

	if (p_hash_moves == NULL) 
	{
		std::cout << "Transposition_table::TEST_Hash_index_print  p_hash_moves == NULL " << std::endl;
		exit(1); 
	}

	for (uint32_t cnt = 0; cnt <= max_index_hash; cnt++)
	{
		if (p_hash_moves[cnt].key_lock_32_move != 0) yes_move = yes_move + 1 ;

		if (p_hash_moves[cnt].key_lock_32_score != 0) yes_score = yes_score + 1 ;

		if (p_hash_moves[cnt].key_lock_32_move == 0) no_move = no_move + 1 ;

		if (p_hash_moves[cnt].key_lock_32_score == 0) no_score = no_score + 1 ;
	}

	full_move = yes_move + no_move;

	full_score = yes_score + no_score;


	std::cout << "  "<< std::endl;
	std::cout << "    " << max_index_hash << std::endl;

	if (full_move != 0)
	{
		std::cout << "full_move = " << full_move << std::endl;
	}

	if (full_score != 0)
	{
		std::cout << "full_score = " << full_score << std::endl;
	}

	std::cout << "  "<< std::endl;

	if (yes_move != 0)
	{
		std::cout << "yes_move = " << yes_move << std::endl;
	}

	if (yes_score != 0) 
	{
		std::cout << "yes_score = " << yes_score << std::endl;
	}

	std::cout << "  "<< std::endl;

	if (no_move != 0)
	{
		std::cout << "no_move = " << no_move << std::endl;
	}

	if (no_score != 0)
	{
		std::cout << "no_score = " << no_score << std::endl;
	}

	std::cout << "  "<< std::endl;

	if (no_move != 0)
	{
		std::cout << " 100 * yes_move/no_move = " << 100 * yes_move/no_move << std::endl;
	}

	if (no_score != 0)
	{
		std::cout << " 100 * yes_score/no_score = " << 100 * yes_score/no_score << std::endl;
	}

	std::cout << "  "<< std::endl;
}

//	===================================================================
//        
//     flag_insert_hash_move 2   1
void Transposition_table::insert_hash_moves
(
	struct List & list,//   
	const int32_t hash_moves,//
	uint8_t  & flag_insert_hash_move//     -     
)
{
	int32_t move_s = 0;
	int32_t score_s;//     
	uint8_t j;

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
    
	static int kolizii = 0; 
	static int enter = 0; 
	int pozition = 0;

	int move_print;

	enter = enter + 1;

#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

	flag_insert_hash_move = 1;//   

	// 1  -  
	for (j = 0; 
	( (list.move[j] != hash_moves) 
	&& (j < list.end_list) ); 
	j++);


//    .   
#if TEST_H

	//--------------------
	if (j == end_list)
	//if (1)
	{	
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
		Test_Hash.open ("_TEST_HASH.txt",std::ios::app);
		//Test_Hash.open ("_TEST_HASH.txt");
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

		for(unsigned int ihm = 0; ihm <= max_index_hash; ihm++)
		{
			if(hash_moves[ihm].key_lock_32_move != -1) pozition = pozition + 1;
		}

		Test_Hash << "  "<< max_index_hash <<std::endl;
		Test_Hash << "    "<< pozition <<std::endl;

		move_print = hash_moves[ind].move;

		kolizii = kolizii + 1;

		Test_Hash << " "<< enter <<std::endl;
		Test_Hash << " "<< kolizii <<std::endl;
		Test_Hash << "depth "<< depth <<std::endl;
		Test_Hash << "hash_moves[].move_delta_depth " << hash_moves[ind].move_delta_depth << std::endl;
		//Test_Hash << "key "<< key <<std::endl;
		Test_Hash << "hash_moves[].key " << hash_moves[ind].key_lock_32_move << std::endl;
		Test_Hash << "hash_moves[].move "<< move_print <<std::endl;

		//------------------------------------------
		Test_Hash << "  " << UTIL::public_int_to_char_board(((move_print>>24)& 7),1)<< std::endl;
		Test_Hash << "hash_moves[].score_move " << hash_moves[ind].score << std::endl;

		//    e2-e4
		//------------------------------
		Test_Hash << " " << (UTIL::public_x_to_notation(((move_print>>12)& 63)%8));
		Test_Hash << "" << (1 + ((move_print>>12)& 63)/8);//<< std::endl;
		//Test_Hash<< std::endl;
		Test_Hash << " " << (UTIL::public_x_to_notation(((move_print>>18)& 63)%8));
		Test_Hash << "" << (1 + ((move_print>>18)& 63)/8)<< std::endl;   
		//------------------------------
		//  
		//0 -   1    2   3    4    5    
		//12 -    13 -    14 -    15 -    
		//22 -      23 -      24 -      
		//25 -      
		Test_Hash << "  " << ((move_print>>6)& 63)  << std::endl;
		Test_Hash << "  " << UTIL::public_int_to_char_board(( move_print & 63),1)<< std::endl;
		//Test_Hash << "  " << ((move_print>>12)& 63)  << std::endl;
		//Test_Hash << "  " << ((move_print>>18)& 63)  << std::endl;
     
		Test_Hash << std::endl;
		//------------------------------------------

		Test_Hash << "end_list= "<< end_list <<std::endl;
		Test_Hash << "j= "<< j <<std::endl;
		Test_Hash << "-----------------------------------"<<std::endl;

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
		Test_Hash.close();
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

	}	
#endif 


	//       
	if (j < list.end_list)
	{	
		//------------------------------------------------------------------------
		// 2  - 
		move_s  = list.move[j];
		score_s = list.sorting_score[j];
		//------------------------------------------------------------------------

		// 3    
		//             
		for (uint8_t i = j; i > 0; i--)
		{	
			list.move[i] = list.move[i-1];
			list.sorting_score[i] = list.sorting_score[i-1];
		}	

		//------------------------------------------------------------------------
		// 4     -
		list.move[0] = move_s;
		list.sorting_score[0] = score_s;
		//------------------------------------------------------------------------

		flag_insert_hash_move = 2;//  
	}
}

